/* iqlvms.f -- translated by f2c (version 20041007).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/*     SUBROUTINE IQLVMS */
/*     ================= */


/* ****************************************************************** */

/*     PROGRAMMCHARAKTERISTIK */
/*     ---------------------- */

/* IQLVMS BERECHNET MIT DEM IMPLIZITEN QL-ALGORITHMUS DIE */
/* EIGENWERTE UND EIGENVEKTOREN */

/*     BEDEUTUNG DER PARAMETER: */

/*       NM      (I) :   VEREINBARTE DIMENSION VON Z */
/*       N       (I) :   DIMENSION */
/*       D       (I) :   DIAGONALE DER TRIDIAGONALMATRIX */
/*               (O) :   EIGENWERTE */
/*       E       (I) :   NEBENDIAGONALE DER TRIDIAGONALMATRIX */
/*       Z       (I) :   EINIGE ZEILEN DER */
/*                       TRANSFORMATIONSMATRIX AUF TRIDIAGONALGESTALT */
/*               (O) :   EIGENVEKTORKOMPONENTEN DER URSPRUNGSMATRIX */
/*       IEV     (I) :   =0: KEINE EV-BERECHNUNG */
/*                       =K: JE K EV-KOMPONENTEN ALLER EIGENVEKTOREN */
/*       IER     (O) :   FEHLERANZEIGER; */
/*                       NUMMER DES EIGENWERTES, BEI DEM DIE MAXIMALE */
/*                       ITERATIONSZAHL VON 30 ERREICHT WURDE; */
/*                       (IER-1) EIGENWERTE SIND KORREKT */

/* ********************************************************************** */

/* Subroutine */ int iqlvms_(integer *nm, integer *n, doublereal *d__, 
	doublereal *e, doublereal *z__, integer *iev, integer *ier)
{
    /* Initialized data */

    static doublereal eps = 1e-16;
    static doublereal epss = 1e-8;
    static doublereal dinf = 1e20;
    static doublereal dinf2 = 1e40;
    static doublereal dmin__ = 1e-20;

    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    double sqrt(doublereal), d_sign(doublereal *, doublereal *);

    /* Local variables */
    static doublereal b, c__, f, g;
    static integer i__, j, k, l, m;
    static doublereal p, r__, s, t;
    static integer ka, ke;
    static doublereal pa;
    static integer ii, ki, kk, ki1, mm1, mml;
    static doublereal psi, psj, anorm;

    /* Parameter adjustments */
    --z__;
    --e;
    --d__;

    /* Function Body */
    *ier = 0;
    if (*n == 1) {
	return 0;
    }
/* *** 7.2.02 *** Uebernahme einer erweiterten Programmversion *** */
    anorm = 0.f;
    r__ = 0.f;
/* Alle Elemente der Nebendiagonale 1 nach vorn rcken */
/* ANORM := 1-Norm der Zeile mit grter 1-Norm */
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	s = e[i__];
	e[i__ - 1] = s;
	s = abs(s);
	p = (d__1 = d__[i__ - 1], abs(d__1)) + r__ + s;
	if (p > anorm) {
	    anorm = p;
	}
	r__ = s;
/* L100: */
    }
    p = (d__1 = d__[*n], abs(d__1)) + r__;
    if (p > anorm) {
	anorm = p;
    }
    e[*n] = 0.f;
    i__1 = *n;
    for (l = 1; l <= i__1; ++l) {
	j = 0;
/*     ********** LOOK FOR SMALL SUBDIAGONAL ELEMENT ********** */
L105:
	i__2 = *n;
	for (m = l; m <= i__2; ++m) {
	    if (m == *n) {
		goto L120;
	    }
	    if ((d__3 = e[m], abs(d__3)) <= eps * ((d__1 = d__[m], abs(d__1)) 
		    + (d__2 = d__[m + 1], abs(d__2)))) {
		goto L120;
	    }
	    if ((d__1 = e[m], abs(d__1)) <= dmin__ * anorm) {
		goto L120;
	    }
/* L110: */
	}
L120:
	p = d__[l];
	mm1 = m - 1;
	if (m == l) {
	    goto L215;
	}
	if (j == 30) {
	    goto L1000;
	}
	++j;
/*     ********** FORM SHIFT ********** */
	g = (d__[l + 1] - p) / (e[l] * 2.f);
	r__ = sqrt(g * g + 1.f);
	s = p - e[l] / (g + d_sign(&r__, &g));
	if (m == l + 1) {
	    goto L148;
	}
	t = s;
/* Computing MAX */
	d__1 = abs(s), d__2 = anorm / *n;
	r__ = max(d__1,d__2);
	for (i__ = 1; i__ <= 6; ++i__) {
	    pa = p;
	    psi = d__[m] - t;
	    psj = -1.f;
	    i__2 = mm1;
	    for (kk = l; kk <= i__2; ++kk) {
		k = l + mm1 - kk;
		if (abs(psi) >= eps * (d__1 = e[k], abs(d__1))) {
		    goto L125;
		}
		psi = dinf;
		psj = dinf2;
		goto L130;
L125:
		p = e[k] / psi;
		psi = d__[k] - t - p * e[k];
		psj = p * p * psj - 1.f;
L130:
		;
	    }
	    if (abs(psj) <= dmin__) {
		goto L148;
	    }
	    p = psi / psj;
	    c__ = p;
	    if (abs(p) > r__ * .5f) {
		c__ = d_sign(&r__, &p);
	    }
	    t -= c__;
	    if (abs(p) <= epss * r__) {
		goto L145;
	    }
/* L140: */
	}
	goto L148;
L145:
	s = t;
L148:
	g = d__[m] - s;
	s = 1.f;
	c__ = 1.f;
	p = 0.f;
	mml = m - l;
	ki1 = mm1 * *nm + 1;
	ka = ki1 - *nm;
	ke = ka + *iev - 1;
/*     ********** FOR I=M-1 STEP -1 UNTIL L DO ********** */
	i__2 = mml;
	for (ii = 1; ii <= i__2; ++ii) {
	    i__ = m - ii;
	    f = s * e[i__];
	    b = c__ * e[i__];
	    if (abs(f) < abs(g)) {
		goto L150;
	    }
	    c__ = g / f;
	    r__ = sqrt(c__ * c__ + 1.);
	    e[i__ + 1] = f * r__;
	    s = 1.f / r__;
	    c__ *= s;
	    goto L160;
L150:
	    s = f / g;
	    r__ = sqrt(s * s + 1.);
	    e[i__ + 1] = g * r__;
	    c__ = 1.f / r__;
	    s *= c__;
L160:
	    g = d__[i__ + 1] - p;
	    r__ = (d__[i__] - g) * s + c__ * 2.f * b;
	    p = s * r__;
	    d__[i__ + 1] = g + p;
	    g = c__ * r__ - b;
	    if (*iev == 0) {
		goto L200;
	    }
/*     ********** FORM VECTOR ********** */
	    i__3 = ke;
	    for (ki = ka; ki <= i__3; ++ki) {
		f = z__[ki1];
		b = z__[ki];
		z__[ki1] = s * b + c__ * f;
		z__[ki] = c__ * b - s * f;
		++ki1;
/* L180: */
	    }
	    ki1 = ka;
	    ka -= *nm;
	    ke -= *nm;
L200:
	    ;
	}
	d__[l] -= p;
	e[l] = g;
	e[m] = 0.f;
	goto L105;
L215:
/* L250: */
	;
    }
    return 0;
L1000:
    *ier = l;
    return 0;
} /* iqlvms_ */

